//Slide Thingy
addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "modernsonic"
		and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			if not (player.slidecanceltimer)
				player.slidecanceltimer = 0
			elseif player.slidecanceltimer > 0
				player.slidecanceltimer = $1-1
			end
			if P_PlayerInPain(player)
				player.sliding = 0
			end
			if not (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
				player.usedown = false
			end
			if (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
			and not (player.powers[pw_carry])
			and not (player.exiting)
			and not (player.pflags & PF_STASIS)
			and not P_PlayerInPain(player)
			and player.playerstate == PST_LIVE
			and player.speed > FixedMul(FRACUNIT, player.mo.scale)
			and P_IsObjectOnGround(player.mo)
			and (player.sliding == 0)
			and player.usedown == false
			and player.wasstomping == false
			and not (player.silv_grabbed)
				player.slidecanceltimer = 13
				player.usedown = true
				player.mo.state = S_PLAY_SLIDE
				player.sliding = 1
				player.pflags = $1|PF_SLIDING
				S_StartSound(player.mo, sfx_sldst)
				if not (player.mo.eflags & MFE_UNDERWATER)
					
					if player.voices == 1
						PlayModernSound(player, TYPE_SLIDEJ)
					elseif player.voices == 2
						PlayModernSound(player, TYPE_SLIDER)
					elseif player.voices == 3
						PlayModernSound(player, TYPE_SLIDED)	
					elseif player.voices == 4
						PlayModernSound(player, TYPE_FEELINGGOOD)	
					end
				end
				if player.speed < FixedMul(15*FRACUNIT, player.mo.scale)
					P_InstaThrust(player.mo, player.drawangle, FixedMul(15*FRACUNIT, player.mo.scale))
				end
			end
			if player.sliding == 1
			and player.speed == 0
				if P_IsObjectOnGround(player.mo)
				and player.mo.state == S_PLAY_STND
					player.sliding = 0
					player.slidecanceltimer = 0
				end
				if ((player.mo.ceilingz - player.mo.floorz) > skins[player.mo.skin].height + FRACUNIT) 
					player.sliding = 0
					player.slidecanceltimer = 0
				elseif ((player.mo.ceilingz - player.mo.floorz) < skins[player.mo.skin].height + FRACUNIT)
					player.pflags = $1|PF_SLIDING			
					player.pflags = $1|MF_SLIDEME
					P_InstaThrust(player.mo, player.mo.angle, FixedMul(10*FRACUNIT, player.mo.scale))
					player.mo.state = S_PLAY_SLIDE
					player.height = P_GetPlayerSpinHeight(player)
				end
			end
			if not (P_IsObjectOnGround(player.mo))
			and player.sliding == 1
			and player.mo.state ~= S_PLAY_SPRING
			and not (player.pflags & PF_JUMPED)
				player.pflags = $1 & ~PF_SLIDING
				player.pflags = $1 & ~MF_SLIDEME
				player.sliding = 0
				player.slidecanceltimer = 0
				if player.pflags & PF_JUMPED
					player.mo.state = S_PLAY_HOP
				else
					player.mo.state = S_PLAY_FALL
				end
			end
			if player.pflags & PF_JUMPED
				if player.mo.state == S_PLAY_SLIDE
					player.mo.state = S_PLAY_HOP
					player.sliding = 0
					player.slidecanceltimer = 0
				end
				player.crushtimer = $1+1
			else 
				player.crushtimer = 0
			end
			if player.crushtimer > 0 and player.crushtimer < 3
				if((player.mo.ceilingz - player.mo.floorz) < skins[player.mo.skin].height + FRACUNIT)
					player.pflags = $1|PF_SLIDING			
					player.pflags = $1|MF_SLIDEME
					P_InstaThrust(player.mo, player.mo.angle, FixedMul(10*FRACUNIT, player.mo.scale))
					player.mo.state = S_PLAY_SLIDE
					player.height = P_GetPlayerSpinHeight(player)
					player.sliding = 1
				end
			end
			if player.mo.state == S_PLAY_SLIDE
				player.boosting = false
				player.airboost = false
				player.superboost = false
				player.pflags = $1|PF_STASIS
				if player.powers[pw_shield] == SH_ELEMENTAL
				and not (player.mo.eflags & MFE_UNDERWATER)
				and not (player.mo.eflags & MFE_TOUCHWATER)
				and (leveltime & 1)
				and player.speed > FixedMul(4*FRACUNIT, player.mo.scale)
					P_ElementalFire(player)
				end
				player.slideregen = $1+1
				if player.mo.standingslope == nil
					player.mo.friction = FRACUNIT-1000
				elseif player.mo.standingslope ~= nil
					if (player.mo.z < player.prevz and not (player.mo.eflags & MFE_VERTICALFLIP))
					or (player.mo.z > player.prevz and (player.mo.eflags & MFE_VERTICALFLIP))
						player.mo.friction = 549*(29 * FRACUNIT/32)/500
						player.prevz = player.mo.z
					elseif (player.mo.z > player.prevz and not (player.mo.eflags & MFE_VERTICALFLIP))
					or (player.mo.z < player.prevz and (player.mo.eflags & MFE_VERTICALFLIP))
						player.prevz = player.mo.z
						player.mo.friction = FRACUNIT-1000
					elseif player.mo.z == player.prevz
						player.mo.friction = FRACUNIT-1000
					end
				end
				if not (S_SoundPlaying(player.mo, sfx_sldst))
				and not (S_SoundPlaying(player.mo, sfx_sldng))
					S_StartSound(player.mo, sfx_sldng)
				end
				local xr = P_ReturnThrustX(player.mo, player.drawangle - ANGLE_45, 10*player.mo.scale)
				local yr = P_ReturnThrustY(player.mo, player.drawangle - ANGLE_45, 10*player.mo.scale)
				local xl = P_ReturnThrustX(player.mo, player.drawangle + ANGLE_45, 10*player.mo.scale)
				local yl = P_ReturnThrustY(player.mo, player.drawangle + ANGLE_45, 10*player.mo.scale)
				if not (player.slideright)
					player.slideright = P_SpawnMobj(player.mo.x + xr, player.mo.y + yr, player.mo.z, MT_SLIDEFXR)
					player.slideright.angle = player.drawangle
					player.slideright.scale = player.mo.scale*4/3
					if player.powers[pw_super] == 0
						if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
						and not (player.mo.eflags & MFE_UNDERWATER)
							player.slideright.color = SKINCOLOR_ORANGE	
						elseif player.mo.color == SKINCOLOR_BLUE
							player.slideright.color = SKINCOLOR_CYAN
						else
							player.slideright.color = player.mo.color
						end
					else
						player.slideright.color = SKINCOLOR_YELLOW
					end
				elseif player.slideright and player.slideright.valid
					player.slideright.angle = player.drawangle
					player.slideright.scale = player.mo.scale*4/3
					if player.mo.eflags & MFE_VERTICALFLIP then
						player.slideright.flags2 = $1|MF2_OBJECTFLIP // flip gravity!
						player.slideright.eflags= $1|MFE_VERTICALFLIP
						P_TeleportMove(player.slideright, player.mo.x + xr, player.mo.y + yr, player.mo.z+player.mo.height)
					else
						player.slideright.flags2 = $1&~MF2_OBJECTFLIP // flip gravity!
						player.slideright.eflags= $1&~MFE_VERTICALFLIP
						P_TeleportMove(player.slideright, player.mo.x + xr, player.mo.y + yr, player.mo.z)
					end
					if player.powers[pw_super] == 0
						if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
						and not (player.mo.eflags & MFE_UNDERWATER)
							player.slideright.color = SKINCOLOR_ORANGE	
						elseif player.mo.color == SKINCOLOR_BLUE
							player.slideright.color = SKINCOLOR_CYAN
						else
							player.slideright.color = player.mo.color
						end
					else
						player.slideright.color = SKINCOLOR_YELLOW
					end
				end
				if not (player.slideleft)
					player.slideleft = P_SpawnMobj(player.mo.x + xl, player.mo.y + yl, player.mo.z, MT_SLIDEFXL)
					player.slideleft.angle = player.drawangle
					player.slideleft.scale = player.mo.scale*4/3
					if player.powers[pw_super] == 0
						if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
						and not (player.mo.eflags & MFE_UNDERWATER)
						player.slideleft.color = SKINCOLOR_ORANGE	
						elseif player.mo.color == SKINCOLOR_BLUE
							player.slideleft.color = SKINCOLOR_CYAN
						else
							player.slideleft.color = player.mo.color
						end
					else
						player.slideleft.color = SKINCOLOR_YELLOW
					end	
				elseif player.slideleft and player.slideleft.valid
					player.slideleft.angle = player.drawangle
					player.slideleft.scale = player.mo.scale*4/3
					if player.mo.eflags & MFE_VERTICALFLIP then
						player.slideleft.flags2 = $1|MF2_OBJECTFLIP // flip gravity!
						player.slideleft.eflags= $1|MFE_VERTICALFLIP
						P_TeleportMove(player.slideleft, player.mo.x + xl, player.mo.y + yl, player.mo.z+player.mo.height)
					else
						player.slideleft.flags2 = $1&~MF2_OBJECTFLIP // flip gravity!
						player.slideleft.eflags= $1&~MFE_VERTICALFLIP
						P_TeleportMove(player.slideleft, player.mo.x + xl, player.mo.y + yl, player.mo.z)
					end
					if player.powers[pw_super] == 0
						if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
						and not (player.mo.eflags & MFE_UNDERWATER)
							player.slideleft.color = SKINCOLOR_ORANGE	
						elseif player.mo.color == SKINCOLOR_BLUE
							player.slideleft.color = SKINCOLOR_CYAN
						else
							player.slideleft.color = player.mo.color
						end
					else
						player.slideleft.color = SKINCOLOR_YELLOW
					end	
				end
				for i=(leveltime%7)/2,(leveltime%7) do
					local particle = P_SpawnMobj(player.mo.x, player.mo.y,
					player.mo.z + ((player.mo.eflags & MFE_VERTICALFLIP)/MFE_VERTICALFLIP * (player.mo.height - mobjinfo[MT_SPINDUST].height)), MT_SPINDUST)
					if (player.powers[pw_shield] == SH_ELEMENTAL and not (player.mo.eflags & MFE_TOUCHWATER or player.mo.eflags & MFE_UNDERWATER)) then
						particle.state = S_SPINDUST_FIRE1
						particle.bubble = false
					elseif (player.mo.eflags & MFE_TOUCHWATER or player.mo.eflags & MFE_UNDERWATER) then
						particle.state = S_SPINDUST_BUBBLE1
						particle.bubble = true
					else
						particle.state = S_SPINDUST1
						particle.bubble = false
					end
					particle.target = player.mo
					particle.eflags = $1 | (player.mo.eflags & MFE_VERTICALFLIP)
					particle.scale = player.mo.scale*2/3
					P_SetObjectMomZ(particle, player.speed/FRACUNIT*FRACUNIT/50+P_RandomByte()<<10, false)
					P_InstaThrust(particle, player.drawangle+(P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT), FixedMul(-player.speed/FRACUNIT*FRACUNIT/12-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
					P_TryMove(particle, particle.x+particle.momx, particle.y+particle.momy, true)
				end
			else
				player.prevz = player.mo.z
				player.slideregen = 0
				if player.slideright and player.slideright.valid
					P_RemoveMobj(player.slideright)
					player.slideright = nil
				end
				if player.slideleft and player.slideleft.valid
					P_RemoveMobj(player.slideleft)
					player.slideleft = nil
				end
			end
			if player.sliding == 1
			and not (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
			and player.slidecanceltimer == 0
			and ((player.mo.ceilingz - player.mo.floorz) > skins[player.mo.skin].height + FRACUNIT)
			and player.playerstate == PST_LIVE
				player.sliding = 0
			end
			if (player.mo.state == S_PLAY_SPRING) then
				player.slidecanceltimer = 0
			end
			if player.sliding == 1
			or player.slidecanceltimer > 0
				if not (player.mo.state == S_PLAY_SPRING)
					player.drawangle = R_PointToAngle2(player.mo.x, player.mo.y, (player.mo.x+player.mo.momx), (player.mo.y+player.mo.momy))
					player.mo.state = S_PLAY_SLIDE
					player.height = P_GetPlayerSpinHeight(player)
				end	
			end
			if player.sliding == 0
			and player.mo.state ~= S_PLAY_CROUCH1
			and player.mo.state ~= S_PLAY_CROUCH2
				if ((player.mo.ceilingz - player.mo.floorz) > skins[player.mo.skin].height + FRACUNIT)
					player.height = skins[player.mo.skin].height
				end
			end
		end
	end
end)