//Similar to the previous boost shake script, this one adds it for the stomp
local client
local function stompshake(v, player)
client = player
	end
hud.add(stompshake)

//Makes the Ground Pou- i mean Stomp work.
addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "modernsonic")
		and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			if not (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
				player.stompdown = false
			end
			if not (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
			and player.stomping == false
			and player.wasstomping == true
				player.wasstomping = false
			end
			if player.stomptimer > 0 
				player.stomptimer = $1-1
			end
			if player.stomping == true
			and player.stomptimer == 0
				player.stomping = false
			end
			if P_IsObjectOnGround(player.mo)
			and (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
				player.stompdown = true
			end
			if player.playerstate == PST_DEAD
				player.stomping = false
				player.wasjuststomping = false
				player.crouching = false
			end
			if player.springlocktimer > 0
				player.springlocktimer = $1-1
			end
			if (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
            and (P_IsObjectOnGround(player.mo) == false)
			and not (player.stomping == true) 
			and player.stompdown == false
			and not (player.powers[pw_carry])
			and not (player.homing)
			and player.powers[pw_nocontrol] == 0
			and not (P_PlayerInPain(player))
			and player.playerstate == PST_LIVE
			and player.superboost == false
			and player.springlocktimer == 0
			and not (P_IsObjectInGoop(player.mo))
			and not (player.pflags & PF_STASIS)
			and not (player.pflags & PF_FULLSTASIS)
			and not (player.silv_grabbed) //Breaks with Silver otherwise
				player.wasstomping = true
				player.stomptimer = 2*TICRATE
				player.mo.momz = FixedMul(-50*FRACUNIT, P_GravAndScale(player.mo))
				player.stompdown = true
				player.mo.state = S_PLAY_FALL
				if not (player.mo.eflags & MFE_UNDERWATER)
					S_StartSound(player.mo, sfx_stmps)
					if player.voices == 1
						PlayModernSound(player, TYPE_STOMPJ)
					elseif player.voices == 2
						PlayModernSound(player, TYPE_STOMPR)
					elseif player.voices == 3
						PlayModernSound(player, TYPE_STOMPD)	
					elseif player.voices == 4
						PlayModernSound(player, TYPE_FEELINGGOOD)	
					end
				else
					S_StartSound(player.mo, sfx_stmpsw)
				end
				player.stomping = true
			end
			if player.stomping == true
			and not (player.mo.state == S_PLAY_SPRING)
			and not (player.powers[pw_nocontrol])
			and not (P_PlayerInPain(player))
			and player.playerstate == PST_LIVE
				player.mo.state = S_PLAY_FALL
			end
			if player.springheight ~= 0
				P_SetObjectMomZ(player.mo, player.springheight+5*FRACUNIT, false)
				player.stomping = false
				player.springheight = 0
			end
			if player.panim == PA_ROLL
			or player.panim == PA_JUMP
			or P_IsObjectOnGround(player.mo)
			or (P_IsObjectInGoop(player.mo))
			or player.powers[pw_carry]
			or player.homing
			or player.powers[pw_nocontrol] 
			or P_PlayerInPain(player)
			or player.pflags & PF_STASIS
			or player.pflags & PF_FULLSTASIS
				player.stomping = false
			end
			if player.stomping == true 
			and not (player.powers[pw_carry])
			and not (player.powers[pw_nocontrol])
			and not (P_PlayerInPain(player))
				player.abilitylock = true
				player.pflags = $1 & ~PF_NOJUMPDAMAGE
				player.pflags = $1|PF_JUMPED
				player.pflags = $1|PF_THOKKED
				if player.speed > FixedMul(FRACUNIT, player.mo.scale)
				and (leveltime % 2 == 0)
					player.mo.momy = $1*5/8
					player.mo.momx = $1*5/8
				elseif player.speed < FRACUNIT
					P_InstaThrust(player.mo, player.mo.angle, 0)
				end
				player.mo.momz = FixedMul(-45*FRACUNIT, P_GravAndScale(player.mo))
				if player.stomptimer <= 102
					local stompaura = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_STOMPAURA)
					if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
					and not (player.mo.eflags & MFE_UNDERWATER)
					and player.powers[pw_super] == 0
						stompaura.color = SKINCOLOR_ORANGE
					else
						stompaura.color = player.mo.color
					end
					stompaura.target = player.mo
					stompaura.scale = P_RandomRange(4000/3, 2000/3)*player.mo.scale/1000
					if player.mo.eflags & MFE_VERTICALFLIP then
						stompaura.flags2 = $1|MF2_OBJECTFLIP // flip gravity!
						stompaura.eflags = $1|MFE_VERTICALFLIP
						P_TeleportMove(stompaura, stompaura.target.x, stompaura.target.y, stompaura.target.z-FixedMul(player.mo.height+player.mo.height/5, P_GravAndScale(player.mo)))
					end
					if (leveltime % 2 == 0)
						stompaura.flags2 = $1 & ~MF2_DONTDRAW
					else
						stompaura.flags2 = $1|MF2_DONTDRAW
					end
					local stompeffect = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_STOMPEFFECT)
					if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
					and not (player.mo.eflags & MFE_UNDERWATER)
					and player.powers[pw_super] == 0
						stompeffect.color = SKINCOLOR_ORANGE
					else
						stompeffect.color = player.mo.color
					end
					stompeffect.scale = player.mo.scale
					if player.mo.eflags & MFE_VERTICALFLIP then
						stompeffect.flags2 = $1|MF2_OBJECTFLIP // flip gravity!
					end
				end
			else
				player.stomping = false
			end
			if (P_IsObjectOnGround(player.mo) == true)
			and (player.stomping == false)
			and (player.wasjuststomping == true) then
				player.stompshake = 6
				if not (player.mo.eflags & MFE_UNDERWATER)
					if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
						P_ElementalFire(player, true)
					end
					S_StartSound(player.mo, sfx_stmpg)
				else
					S_StartSound(player.mo, sfx_stmpgw)
				end
				for i = 11,33
					if not (player.mo.eflags & MFE_VERTICALFLIP)
						local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_STOMPDUST)
						dust.target = player.mo
						dust.scale = player.mo.scale/4
						if player.mo.eflags & MFE_VERTICALFLIP then
							dust.flags2 = $1|MF2_OBJECTFLIP // flip gravity!
						end
						local an = i*ANG30
						local speed = FixedMul(dust.info.speed/FRACUNIT, player.mo.scale)
						dust.momx = speed/6*cos(an)
						dust.momy = speed/6*sin(an)
						dust.momz = 0
						if player.powers[pw_super]
							dust.color = SKINCOLOR_YELLOW
						elseif (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
						and not (player.mo.eflags & MFE_UNDERWATER)
						and player.powers[pw_super] == 0
							dust.color = SKINCOLOR_ORANGE
						elseif player.mo.color ~= SKINCOLOR_BLUE
							dust.color = player.mo.color
						else
							dust.color = SKINCOLOR_SAPPHIRE
						end
					else
						local offset = FixedMul(23*FRACUNIT, P_GravAndScale(player.mo))
						local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z-offset, MT_STOMPDUST)
						dust.target = player.mo
						dust.scale = player.mo.scale/4
						if player.mo.eflags & MFE_VERTICALFLIP then
							dust.flags2 = $1|MF2_OBJECTFLIP // flip gravity!
						end
						local an = i*ANG30
						local speed = FixedMul(dust.info.speed/FRACUNIT, player.mo.scale)
						dust.momx = speed/6*cos(an)
						dust.momy = speed/6*sin(an)
						dust.momz = 0
						if player.powers[pw_super]
							dust.color = SKINCOLOR_YELLOW
						elseif (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
						and not (player.mo.eflags & MFE_UNDERWATER)
						and player.powers[pw_super] == 0
							dust.color = SKINCOLOR_ORANGE
						elseif player.mo.color ~= SKINCOLOR_BLUE
							dust.color = player.mo.color
						else
							dust.color = SKINCOLOR_SAPPHIRE
						end
					end
				end
				player.juststomped = true
				if (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
					player.initiatestomptimer = true
				end
			end
			if player.initiatestomptimer == true
				player.stompintoslidetimer = $1+1
			end
			if not (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
				player.stompintoslidetimer = 0
				player.initiatestomptimer = false
			end
			if player.juststomped == true
				if (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
				and player.speed > FixedMul(15*FRACUNIT, player.mo.scale)
				and player.stompintoslidetimer > 2
				and (((player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0) and not (player.mo.flags2 & MF2_TWOD)) or (player.cmd.sidemove ~= 0 and (player.mo.flags2 & MF2_TWOD)))
				
					player.slidecanceltimer = 15
					player.sliding = 1
					player.mo.state = S_PLAY_SLIDE
					player.usedown = true
					player.sliding = 1
					player.pflags = $1|PF_SLIDING
					S_StartSound(player.mo, sfx_sldst)
					if not (player.mo.eflags & MFE_UNDERWATER)
						if player.voices == 1
							PlayModernSound(player, TYPE_SLIDEJ)
						elseif player.voices == 2
							PlayModernSound(player, TYPE_SLIDER)
						elseif player.voices == 3
							PlayModernSound(player, TYPE_SLIDED)
						elseif player.voices == 4
							PlayModernSound(player, TYPE_FEELINGGOOD)	
						end
					end
					player.juststomped = false
				end
				if player.speed <= FixedMul(15*FRACUNIT,player.mo.scale)
				or not (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
					P_InstaThrust(player.mo, player.mo.angle, 0)
					player.juststomped = false
					if not (player.mo.state == S_PLAY_CROUCH1)
					and not (player.mo.state == S_PLAY_CROUCH2)
						player.mo.state = S_PLAY_CROUCH1
					end
					if (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
						player.crouching = true
						player.crouchcanceltimer = 12
					end
				end
			end
			if player.crouchcanceltimer > 0 
				player.crouchcanceltimer = $1-1
			end
			if P_IsObjectOnGround(player.mo)
			and player.speed == 0
			and (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
			and player.playerstate == PST_LIVE
			and player.usedown == false
				if not (player.mo.state == S_PLAY_CROUCH1)
				and not (player.mo.state == S_PLAY_CROUCH2)
					player.mo.state = S_PLAY_CROUCH1
				end
				player.crouching = true
			elseif player.crouching == true
			and (player.mo.state == S_PLAY_CROUCH1 or player.mo.state == S_PLAY_CROUCH2)
			and not (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
			and player.crouchcanceltimer == 0
			and player.playerstate == PST_LIVE
			and ((player.mo.ceilingz - player.mo.floorz) > skins[player.mo.skin].height + FRACUNIT)
				player.crouching = false
				player.mo.state = S_PLAY_STND
			end
			if player.crouching == true
			and ((player.mo.ceilingz - player.mo.floorz) < skins[player.mo.skin].height + FRACUNIT)
				if not (player.mo.state == S_PLAY_CROUCH1)
				and not (player.mo.state == S_PLAY_CROUCH2)
					player.mo.state = S_PLAY_CROUCH1
				end
			end
			if player.mo.state == S_PLAY_CROUCH1
			or player.mo.state == S_PLAY_CROUCH2
				player.panim = PA_IDLE
				if not (P_IsObjectOnGround(player.mo))
					player.mo.state = S_PLAY_WALK
				end
				player.pflags = $1|PF_STASIS
				player.height = P_GetPlayerSpinHeight(player)
			end
			if player.stompshake > 0
				player.stompshake = $1-1
				if client and client.valid and client.mo
					local dist = P_AproxDistance(P_AproxDistance((client.mo.x - player.mo.x)/FRACUNIT, (client.mo.y - player.mo.y)/FRACUNIT), (client.mo.z - player.mo.z)/FRACUNIT)
					if dist >= 0 and dist < (player.powers[pw_super] and 1024 or 512)*player.mo.scale/FRACUNIT
						P_StartQuake(50*FRACUNIT, 1)
					end
				end
			end
			player.wasjuststomping = player.stomping
		end
	end
end)