//This bit somehow adds a localized screenshake. Idea used from Pointy.
local client

////////////////////////////////////////////////////////////////////////
--
-- Originally was Boss HUD rendering code.
-- (c) Inuyasha 2014.
-- Permissionwas granted by Inuyasha to use this code
-- and the associated graphics in other mods.
--
local posy = 0

local function boostbar(v, player)
	client = player
		if player.mo and player.mo.skin != "modernsonic"
			if not hud.enabled("lives")
				hud.enable("lives")
			end
			if not hud.enabled("rings")
				hud.enable("rings")
			end
			if not hud.enabled("time")
				hud.enable("time")
			end
			if not hud.enabled("score")
				hud.enable("score")
			end
		elseif player.mo and player.mo.skin == "modernsonic"
			if not (G_RingSlingerGametype())
				if hud.enabled("time")
					hud.disable("time")
				end
				if hud.enabled("score")
					hud.disable("score")
				end
			end
			if hud.enabled("lives")
				hud.disable("lives")
			end
			if hud.enabled("rings")
				hud.disable("rings")
			end
			
		end
		if player.mo and player.mo.skin == "modernsonic"
        and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		    local boostfill = 0;
			local boostcap = 0;
			local boostdrain = 0;
			if player.boostmeter == nil
				return
			end
			boostcap = $1 + 117
            boostfill = $1 + player.boostmeter
			boostdrain = $1 + player.boostmeter+1
 
			local p_startseg = v.cachePatch("METRENDL")
			local p_onseg    = v.cachePatch("METRMIDL")
			local p_offseg   = v.cachePatch("METRMPTY")
			local p_endseg   = v.cachePatch("METRENDR")
			local p_boost    = v.cachePatch("BOOST")
 
			local posx = 186
			if G_RingSlingerGametype()
				posy = 160
			else
				posy = 174 
			end
			
			v.draw(posx, posy, p_endseg, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
			posx = $1 - 1
			if player.playerstate == PST_LIVE
				if (player.speed > FixedMul(60*FRACUNIT, player.mo.scale) and not (player.powers[pw_carry] == CR_MINECART) and not (player.powers[pw_sneakers]) and not (player.powers[pw_nocontrol]))
				or player.minecartboost == true
				or player.homing
					if (leveltime % 2 == 0)
						v.drawScaled(0, 0, 65355, v.cachePatch("BSTFX"), V_80TRANS|V_SNAPTOLEFT|V_SNAPTOTOP, v.getColormap(-1, SKINCOLOR_SILVER))
					else
						v.drawScaled(320*FRACUNIT, 0, 65355, v.cachePatch("BSTFX"), V_90TRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_FLIP, v.getColormap(-1, SKINCOLOR_SILVER))
					end
				end
			end
			-- Step through backwards, to match the way we're drawing.
			for i = boostcap, 1, -1
					if boostfill >= i
						if player.boostmeter > 70
							v.draw(posx, posy, p_onseg, V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, v.getColormap("SKINCOLOR_YELLOW", SKINCOLOR_YELLOW))
						elseif player.boostmeter > 69
							v.draw(posx, posy, p_onseg, V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, v.getColormap("SKINCOLOR_APRICOT", SKINCOLOR_APRICOT))
						elseif player.boostmeter > 30
							v.draw(posx, posy, p_onseg, V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, v.getColormap("SKINCOLOR_ORANGE", SKINCOLOR_ORANGE))
						elseif player.boostmeter > 29
							v.draw(posx, posy, p_onseg, V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, v.getColormap("SKINCOLOR_FLAME", SKINCOLOR_FLAME))
						elseif player.boostmeter > 0
							v.draw(posx, posy, p_onseg, V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, v.getColormap("SKINCOLOR_RED", SKINCOLOR_RED))
						end
					else
                        v.draw(posx, posy, p_offseg, V_20TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
					end
					posx = $1 - 1;
					
			end
			-- Start segment
			v.draw(posx, posy, p_startseg, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER);
			v.draw(posx+5, posy+5, v.cachePatch("ENERGY"), V_30TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
			v.draw(3, posy-4, v.cachePatch("SPEEDM00"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_PERPLAYER)
			if player.speed >= FRACUNIT
				if player.speed <= 3*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM01"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
				elseif player.speed <= 6*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM02"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
				elseif player.speed <= 9*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM03"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
				elseif player.speed <= 12*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM04"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
				elseif player.speed <= 15*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM05"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
				elseif player.speed <= 19*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM06"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
				elseif player.speed <= 21*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM07"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
				elseif player.speed <= 25*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM08"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
				elseif player.speed <= 30*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM09"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)		
				elseif player.speed <= 39*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM10"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
				elseif player.speed <= 46*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM11"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)		
				elseif player.speed <= 55*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM12"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
				elseif player.speed <= 70*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM13"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
				elseif player.speed >= 70*FRACUNIT
					v.draw(3, posy-4, v.cachePatch("SPEEDM14"), V_10TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)	
				end
			end
			v.draw(posx-46, posy-3, v.cachePatch("SPEED"), V_30TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
			if player.rings < 10
				v.drawString(29, posy+12, "0", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				v.drawString(37, posy+12, "0", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				v.drawString(45, posy+12, player.rings, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			elseif player.rings < 100
				v.drawString(29, posy+12, "0", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				v.drawString(37, posy+12, player.rings, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			else
				v.drawString(29, posy+12, player.rings, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
			end
			if not (gamemap >= 60 and gamemap <= 66)
			and not (G_RingSlingerGametype())
				--Life
				local face = v.getSprite2Patch(player.mo.skin, SPR2_XTRA, (player.powers[pw_super] != 0), 0, 0)
				v.drawScaled((10*FRACUNIT), (8*FRACUNIT), FRACUNIT/2, face, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, player.mo.color))
				if player.lives < 100
					v.drawScaledNameTag(33*FRACUNIT, 12*FRACUNIT, player.lives, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, FRACUNIT/2, SKINCOLOR_WHITE, SKINCOLOR_BLACK)
				end
				--Time
				v.drawScaled((0), (30*FRACUNIT), FRACUNIT, v.cachePatch("MTIME"), V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS)
				local minutes = min(99, G_TicsToMinutes(player.realtime))
				if G_TicsToMinutes(player.realtime) < 10
					v.drawString(14, 41, "0", V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(22, 41, minutes, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				else
					v.drawString(13, 41, minutes, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				end
				if G_TicsToSeconds(player.realtime) < 10
					v.drawString(36, 41, "0", V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(44, 41, G_TicsToSeconds(player.realtime), V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				else
					v.drawString(36, 41, G_TicsToSeconds(player.realtime), V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				end
				if G_TicsToCentiseconds(player.realtime) < 10
					v.drawString(57, 41, "0", V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(65, 41, G_TicsToCentiseconds(player.realtime), V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				else
					v.drawString(57, 41, G_TicsToCentiseconds(player.realtime), V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				end
				v.drawString(51, 41, ":", V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				v.drawString(30, 41, ":", V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				--Score
				v.drawScaled((0), (60*FRACUNIT), FRACUNIT, v.cachePatch("MSCORE"), V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS)
				local pscore = player.score
				local offx = 72
				local zerocount = 9
				
				while (pscore > 0) do
					pscore = $ / 10
					offx = $ - 8
					if (zerocount == 8) then offx = $ + 1 end --tiny little offset hack
					zerocount = $ - 1
				end
				
				local zstring = "000000000"
				
				v.drawString(1, 71, zstring:sub(1,zerocount),  V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				if (player.score) then
					v.drawString(offx, 71, player.score, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				end
			end
			if player.hudring
				if player.hudring > 5
					v.drawScaled((posx*FRACUNIT-58*FRACUNIT), (posy*FRACUNIT+5*FRACUNIT), FRACUNIT+FRACUNIT/10, v.cachePatch("RINGC"), V_10TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
				elseif player.hudring > 4
					v.drawScaled((posx*FRACUNIT-58*FRACUNIT-FRACUNIT/4), (posy*FRACUNIT+5*FRACUNIT), FRACUNIT+FRACUNIT/8, v.cachePatch("RINGC"), V_20TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
				elseif player.hudring > 3
					v.drawScaled((posx*FRACUNIT-58*FRACUNIT-FRACUNIT/2), (posy*FRACUNIT+5*FRACUNIT), FRACUNIT+FRACUNIT/6, v.cachePatch("RINGC"), V_30TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
				elseif player.hudring > 2
					v.drawScaled((posx*FRACUNIT-59*FRACUNIT-FRACUNIT/4), (posy*FRACUNIT+4*FRACUNIT), FRACUNIT+FRACUNIT/4, v.cachePatch("RINGC"), V_40TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
				elseif player.hudring > 1
					v.drawScaled((posx*FRACUNIT-59*FRACUNIT-FRACUNIT/2), (posy*FRACUNIT+4*FRACUNIT-FRACUNIT/2), FRACUNIT+FRACUNIT/3, v.cachePatch("RINGC"), V_50TRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
				end
			end
		end
	end
hud.add(boostbar)


//The Start of a Messy boost code :D 
//Will probably be polished in the next update :P
addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "modernsonic"
		and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			if player.hudring > 0 
				player.hudring = $1-1
			end
			if player.rings > player.prevrings
				if player.hudring == 0
					player.hudring = 6
				end
				player.boostmeter = $1+(player.rings-player.prevrings)*3
				player.prevrings = player.rings
			end
			if player.rings < player.prevrings
				player.prevrings = player.rings
			end
			if player.rings == 0 
			or player.playerstate == PST_DEAD
				player.prevrings = 0
			end
			if (player.mo.eflags & MFE_VERTICALFLIP and not (player.mo.flags2 & MF2_OBJECTFLIP))
			or (player.mo.flags2 & MF2_OBJECTFLIP and not (player.mo.eflags & MFE_VERTICALFLIP))
				player.flipthisboost = player.mo.z+player.mo.height
			elseif (player.mo.eflags & MFE_VERTICALFLIP and (player.mo.flags2 & MF2_OBJECTFLIP))
			or not (player.mo.eflags & MFE_VERTICALFLIP and not (player.mo.flags2 & MF2_OBJECTFLIP))
				player.flipthisboost = player.mo.z
			end
			if player.boostcanceltimer > 0
				player.boostcanceltimer = $1-1
			end
			if player.powers[pw_sneakers]
				player.runshoes = true
			elseif player.runshoes == true
				player.runshoes = false
				if player.speed > FixedMul(36*FRACUNIT, player.mo.scale)
					player.normalspeed = FixedDiv(player.speed, player.mo.scale)
				end
			end
			if player.powers[pw_carry]
			or player.exiting
			or P_PlayerInPain(player)
			or player.powers[pw_nocontrol]
				player.boosting = false
				player.airboost = false
				player.superboost = false
			end
			if player.boosting == false
			and player.airboost == false
			and player.superboost == false
				player.boostregentimer = $1+1
			else
				player.boostregentimer = 0
			end
			if P_IsObjectOnGround(player.mo)
			and player.mo.state == S_PLAY_BOOSTRUN
				player.drawangle = R_PointToAngle2(player.mo.x, player.mo.y, (player.mo.x+player.mo.momx), (player.mo.y+player.mo.momy))
			end
			if player.pflags & PF_JUMPED
			and player.pflags & PF_JUMPDOWN
			and player.speed > FixedMul(60*FRACUNIT, player.mo.scale)
			and not (player.powers[pw_super])
			and not (player.powers[pw_sneakers])
			and not (player.powers[pw_shield] == SH_WHIRLWIND)
				player.mo.momx = $1*5/6
				player.mo.momy = $1*5/6
			end
			if player.playerstate == PST_LIVE
				if player.boosting == true
				or player.airboost == true
				or player.superboost == true
					if P_IsObjectOnGround(player.mo)
					and not (player.mo.eflags & MFE_UNDERWATER)
					and not (player.mo.eflags & MFE_TOUCHWATER)
					and (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
					and (leveltime & 1)
						P_ElementalFire(player)
					end
					player.boosttimer = $1+1
					if player.powers[pw_super] == 0
						if not (player.powers[pw_sneakers])
							player.normalspeed = FixedDiv(player.speed, player.mo.scale)
						else
							player.normalspeed = FixedDiv(player.speed/2, player.mo.scale)
						end
					end
					if player.powers[pw_super]
						if player.superboost == true
							if (leveltime % 5 == 0)
							
								player.rings = player.rings-1
							end
						
							if not (P_IsObjectOnGround(player.mo))
								player.pflags = $1|PF_JUMPED
							else
								player.pflags = $1 & ~PF_THOKKED
							end
							player.pflags = $1|PF_THOKKED
							player.doublejumped = true
							player.justjumped = true
							if player.cmd.buttons & BT_JUMP
								player.mo.momz = $ + P_MobjFlip(player.mo)*player.mo.scale
							elseif (((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))
								player.stompdown = true
								player.mo.momz = $ - P_MobjFlip(player.mo)*player.mo.scale
							end
							if player.mo.momz
								if not ((((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true)) and not (player.cmd.buttons & BT_JUMP)
								or ((((player.cmd.buttons & BT_USE) and player.actionswap == false) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == true))) and player.cmd.buttons & BT_JUMP)
									player.mo.momz = $ - $/abs($)*abs(P_GetMobjGravity(player.mo))
								end
							end
							player.drawnangle = player.mo.angle
							player.mo.state = S_PLAY_BOOSTRUN
							player.mo.flags = $1|MF_NOGRAVITY
						end
					end
				else 
					player.boosttimer = 0
					if player.normalspeed > FixedMul(36*FRACUNIT, player.mo.scale)
					and player.powers[pw_sneakers] == 0
						player.normalspeed = $1-40000
						if player.speed < player.normalspeed-FixedDiv(7*FRACUNIT, player.mo.scale)
							player.normalspeed = FixedDiv(player.speed, player.mo.scale)
						end
					end
					player.mo.flags = $ & ~MF_NOGRAVITY
				end
			end
			if player.normalspeed < 36*FRACUNIT
				player.normalspeed = 36*FRACUNIT
			elseif player.normalspeed > 80*FRACUNIT
				player.normalspeed = 80*FRACUNIT
			end
			if player.boostmeter > 117
				player.boostmeter = 117
			elseif player.boostmeter < 0
				player.boostmeter = 0
				player.boosting = false
			end
			if player.speed > FixedMul(45*FRACUNIT, player.mo.scale)
			and player.stomping == false
			and player.wasjuststomping == false
				player.charflags = $1|SF_RUNONWATER
			else
				player.charflags = $1 & ~SF_RUNONWATER
			end
			if not (((player.cmd.buttons & BT_USE) and player.actionswap == true) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == false))
				if P_IsObjectOnGround(player.mo)
					player.airboost = false
				end
				player.minecartboost = false
			end
			if player.speed == 0 
			and P_IsObjectOnGround(player.mo)
			and player.realtime > 3*TICRATE
			and player.crouching == true
			or player.boostregentimer > 4*TICRATE
			or player.sliding == 1
					player.boostregen = $1+1
					if player.boostregen > 7
					and player.sliding == 0
						player.boostmeter = $1+1
						player.boostregen = 0
					end
					if player.boostregen > 7
					and player.sliding == 1
						player.boostmeter = $1+2
						player.boostregen = 0
					end
				end
			if player.airboost == true
			or player.homing
				player.boosting = false
			end
			if (((player.cmd.buttons & BT_USE) and player.actionswap == true) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == false))
			and player.boostheld == false
			and player.boostmeter > 0
			and not (player.exiting)
			and player.playerstate == PST_LIVE
			and player.airboost == false
			and not (P_PlayerInPain(player))
			and not (player.homing)
			and player.abilitylock == false
			and not (player.pflags & PF_FULLSTASIS)
			and not (player.silv_grabbed)
				if (player.powers[pw_carry] == CR_MINECART)
				and P_IsObjectOnGround(player.mo.tracer)
					if player.minecartboost == false
						player.boostmeter = $1 - 10
						if not (player.mo.eflags & MFE_UNDERWATER)
							S_StartSound(player.mo, sfx_boost2)
						else
							S_StartSound(player.mo, sfx_wtbst2)
						end
						if not (player.mo.eflags & MFE_UNDERWATER)
							if player.voices == 1
								PlayModernSound(player, TYPE_BOOSTJ)
							elseif player.voices == 2
								PlayModernSound(player, TYPE_BOOSTR)
							elseif player.voices == 3
								PlayModernSound(player, TYPE_BOOSTD)
							elseif player.voices == 4
								PlayModernSound(player, TYPE_FEELINGGOOD)	
							end
						end
						player.boostshake = 8
					
						local boostshockwave = P_SpawnMobj(player.mo.x, player.mo.y, player.flipthisboost, MT_BOOSTSHOCKWAVE)
						boostshockwave.target = player.mo
						if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
						and player.powers[pw_super] == 0
						and not (player.mo.eflags & MFE_UNDERWATER)
							boostshockwave.color = SKINCOLOR_ORANGE
						elseif player.mo.color ~= SKINCOLOR_BLUE
							boostshockwave.color = boostshockwave.target.color
						else 
							boostshockwave.color = SKINCOLOR_SKY
						end
						boostshockwave.scale = player.mo.scale
						player.minecartboost = true
					end
				end
				if player.boosting == false
				and player.airboost == false
				and not (player.powers[pw_carry])
				and player.powers[pw_nocontrol] == 0
				and not (P_PlayerInPain(player))
				//and player.walljumped == false
					player.charflags = $1|SF_RUNONWATER
					if P_IsObjectOnGround(player.mo)
						player.boosting = true
						player.boostcanceltimer = 5
						player.airboost = false
						P_InstaThrust(player.mo, player.mo.angle, FixedMul(80*FRACUNIT, player.mo.scale))
						player.boostmeter = $1 - 10
						player.boostheld = true
						if not (player.mo.eflags & MFE_UNDERWATER)
							S_StartSound(player.mo, sfx_boost1)
						else
							S_StartSound(player.mo, sfx_wtbst1)
						end
					elseif not (player.pflags & PF_STASIS)
					and not (player.pflags & PF_FULLSTASIS)
						if not (player.powers[pw_super])
							player.airboost = true
							if not (player.mo.eflags & MFE_UNDERWATER)
								S_StartSound(player.mo, sfx_boost2)
							else
								S_StartSound(player.mo, sfx_wtbst2)
							end
						else
							if not (player.mo.eflags & MFE_UNDERWATER)
								S_StartSound(player.mo, sfx_boost1)
							else
								S_StartSound(player.mo, sfx_wtbst1)
							end
							player.superboost = true
							player.boostcanceltimer = 5
						end
						player.jumptimer = 0
						player.mo.state = S_PLAY_AIRBOOST
					 	player.boostmeter = $1 - 12
						if player.mo.momz > FixedMul(0, P_GravAndScale(player.mo))
							player.mo.momz = 0
						end
						player.boostheld = true
						player.pflags = $1 & ~PF_JUMPED
						if player.speed < FixedMul(66*FRACUNIT, player.mo.scale)
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(66*FRACUNIT, player.mo.scale))
						elseif player.powers[pw_super] == 0
							P_InstaThrust(player.mo, player.mo.angle, player.speed+FixedMul(10*FRACUNIT, player.mo.scale))
						elseif player.powers[pw_super] > 45
							P_InstaThrust(player.mo, player.mo.angle, FixedDiv(player.speed, player.mo.scale))
						end
						player.sonic_ringrangeair = P_SpawnMobj(player.mo.x + player.mo.momx, player.mo.y+ player.mo.momy, player.mo.z + player.mo.momz + player.mo.height/2 - 80*player.mo.scale, MT_RINGRANGE)
						player.sonic_ringrangeair.scale = (player.sonic_ringcharge and 2 or 1)*player.mo.scale
						player.sonic_ringrangeair.height = $*(player.powers[pw_super] and 2 or 1)
						player.sonic_ringrangeair.radius = $*(player.powers[pw_super] and 2 or 1)
						player.sonic_ringrangeair.target = player.mo
						player.sonic_ringrangeair.fuse = 3
					end
					player.drawangle = player.mo.angle
					player.boostshake = 8
					
					local boostshockwave = P_SpawnMobj(player.mo.x, player.mo.y, player.flipthisboost, MT_BOOSTSHOCKWAVE)
					boostshockwave.target = player.mo
					if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
					and player.powers[pw_super] == 0
					and not (player.mo.eflags & MFE_UNDERWATER)
						boostshockwave.color = SKINCOLOR_ORANGE
					elseif player.mo.color ~= SKINCOLOR_BLUE
						boostshockwave.color = boostshockwave.target.color
					else 
						boostshockwave.color = SKINCOLOR_SKY
					end
					boostshockwave.scale = player.mo.scale
					player.drawangle = player.mo.angle
					
					if not (player.mo.eflags & MFE_UNDERWATER)
						if player.voices == 1
							PlayModernSound(player, TYPE_BOOSTJ)
						elseif player.voices == 2
							PlayModernSound(player, TYPE_BOOSTR)
						elseif player.voices == 3
							PlayModernSound(player, TYPE_BOOSTD)
						elseif player.voices == 4
							PlayModernSound(player, TYPE_FEELINGGOOD)	
						end
					end
				end
			end
			if P_IsObjectOnGround(player.mo)
			and (((player.cmd.buttons & BT_USE) and player.actionswap == true) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == false))
			and player.boostheld == true
			and player.airboost == true
				player.boosting = true
				player.airboost = false
			end
			if player.boostshake > 0
				player.boostshake = $1-1
				if client and client.valid and client.mo
					local dist = P_AproxDistance(P_AproxDistance((client.mo.x - player.mo.x)/FRACUNIT, (client.mo.y - player.mo.y)/FRACUNIT), (client.mo.z - player.mo.z)/FRACUNIT)
					if dist >= 0 and dist < (player.powers[pw_super] and 512 or 256)*player.mo.scale/FRACUNIT
						P_StartQuake(25*FRACUNIT, 1)
					end
				end
			end
			if not (((player.cmd.buttons & BT_USE) and player.actionswap == true) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == false))
				player.boostheld = false
				player.boosting = false
				player.boostsound = false
				if player.superboost == true
					player.superboost = false
					if player.mo.momz*P_MobjFlip(player.mo) > 0
						player.mo.momz = $1/2
					end
				end
			end
			if player.powers[pw_sneakers]
			or player.powers[pw_super]
			or player.pflags & PF_FINISHED
				if player.boostmeter < 117
					player.boostmeter = $1+1
				end
			end
			if player.boostmeter == 0
				player.minecartboost = false
				player.boosting = false
			end
			if (player.boosting == true or player.superboost == true)
			and player.playerstate == PST_LIVE
			and player.speed >= FixedMul(44*FRACUNIT, player.mo.scale)
			and player.airboost == false
			and player.powers[pw_nocontrol] == 0
			and not (P_PlayerInPain(player))
			or player.minecartboost == true
				player.boostheld = true
				if player.ringrange == 0
					player.sonic_ringrange = P_SpawnMobj(player.mo.x + player.mo.momx, player.mo.y+ player.mo.momy, player.mo.z + player.mo.momz + player.mo.height/2 - 80*player.mo.scale, MT_RINGRANGE)
					player.sonic_ringrange.scale = (player.sonic_ringcharge and 2 or 1)*player.mo.scale
					
					if player.powers[pw_super]
						player.sonic_ringrange.radius = $*2
						player.sonic_ringrange.height = $*2
					else
						player.sonic_ringrange.radius = $*3/4
						player.sonic_ringrange.height = $*3/4
					end
					player.sonic_ringrange.target = player.mo
					player.ringrange = 1
				end
				if player.sonic_ringrange.valid
					P_TeleportMove(player.sonic_ringrange, player.mo.x, player.mo.y, player.mo.z)
				end
				player.charflags = $1|SF_NOSKID
				if player.powers[pw_sneakers] == 0
				and player.powers[pw_super] == 0
					player.boostdecrease = $1+1
				end
				if player.powers[pw_carry] == CR_MINECART
					if player.boostdecrease >= 5
						player.boostmeter = $1 - 1
						player.boostdecrease = 0
					end
				else
					if player.boostmeter > 0
						if (player.boostdecrease >= 2 and player.boosttimer < 3*TICRATE)
						or (player.boostdecrease >= 4 and player.boosttimer >= 3*TICRATE)
						
							player.boostmeter = $1 - 1
							player.boostdecrease = 0
						end
					end
				end
				if (((player.cmd.buttons & BT_USE) and player.actionswap == true) or ((player.cmd.buttons & BT_CUSTOM1) and player.actionswap == false))
					player.boostheld = true
				end
				if P_IsObjectOnGround(player.mo)
					player.drawangle =  R_PointToAngle2(player.mo.x, player.mo.y, (player.mo.x+player.mo.momx), (player.mo.y+player.mo.momy))
					if player.powers[pw_super]
						player.boostspeed = FixedMul(90*FRACUNIT, player.mo.scale)
					else
						player.boostspeed = FixedMul(80*FRACUNIT, player.mo.scale)
					end
					if player.speed < player.boostspeed
						P_Thrust(player.mo, player.drawangle, player.boostspeed - player.speed)
					end
				else
					if player.powers[pw_super]
						player.drawangle =  R_PointToAngle2(player.mo.x, player.mo.y, (player.mo.x+player.mo.momx), (player.mo.y+player.mo.momy))
						player.boostspeed = FixedMul(90*FRACUNIT, player.mo.scale)
						player.speed = $1-FixedMul(3*FRACUNIT, player.mo.scale)
						if player.speed < player.boostspeed
							P_Thrust(player.mo, player.mo.angle, FRACUNIT)
						end
					end
				end
				local boostaura = P_SpawnMobj(player.mo.x, player.mo.y, player.flipthisboost, MT_BOOSTAURA)
				local boostsparkle = A_BossScream(player.mo, 0, MT_BOXSPARKLE)
				boostaura.target = player.mo
				if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
				and player.powers[pw_super] == 0
				and not (player.mo.eflags & MFE_UNDERWATER)
						boostaura.color = SKINCOLOR_ORANGE
				elseif player.mo.color ~= SKINCOLOR_BLUE
					boostaura.color = boostaura.target.color
				else 
					boostaura.color = SKINCOLOR_SAPPHIRE
				end
				if player.powers[pw_carry] == CR_MINECART
					boostaura.angle = player.mo.angle
				else
					boostaura.angle = R_PointToAngle2(boostaura.x, boostaura.y, (boostaura.target.x+boostaura.target.momx), (boostaura.target.y+boostaura.target.momy))
				end
				P_TeleportMove(boostaura, player.mo.x, player.mo.y, player.flipthisboost)
			
				if (leveltime % 2 == 0)
					boostaura.flags2 = $1 & ~MF2_DONTDRAW
				else
					boostaura.flags2 = $1|MF2_DONTDRAW
				end
				boostaura.scale = player.mo.scale
				local boostafterimage = P_SpawnGhostMobj(boostaura)
				boostafterimage.fuse = 4
				boostafterimage.target = player.mo
				boostafterimage.frame = $1|FF_FULLBRIGHT
				boostafterimage.scale = P_RandomRange(4000/3, 2000/3)*player.mo.scale/1000
				//end
				if not (player.boostmobj1 and player.boostmobj1.valid) then
					player.boostmobj1 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_GFZFLOWER1)
					player.boostmobj1.flags2 = $1|MF2_DONTDRAW
					if not (player.mo.eflags & MFE_UNDERWATER)
						S_StartSound(player.boostmobj1, sfx_boost3)
					else
						S_StartSound(player.boostmobj1, sfx_wtbst3)
					end
					P_TeleportMove(player.boostmobj1, player.mo.x, player.mo.y, player.mo.z)
				elseif (player.boostmobj1 and player.boostmobj1.valid)
					P_TeleportMove(player.boostmobj1, player.mo.x, player.mo.y, player.mo.z)
				end
				if not (player.boostmobj2 and player.boostmobj2.valid) then
					player.boostmobj2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_GFZFLOWER1)
					player.boostmobj2.flags2 = $1|MF2_DONTDRAW
					P_TeleportMove(player.boostmobj2, player.mo.x, player.mo.y, player.mo.z)
				elseif (player.boostmobj2 and player.boostmobj2.valid)
					if not (player.mo.eflags & MFE_UNDERWATER)
						if not (S_SoundPlaying(player.boostmobj2, sfx_boost4))
							S_StartSound(player.boostmobj2, sfx_boost4)
						end
					else
						if not (S_SoundPlaying(player.boostmobj2, sfx_wtbst4))
							S_StartSound(player.boostmobj2, sfx_wtbst4)
						end
					end
					P_TeleportMove(player.boostmobj2, player.mo.x, player.mo.y, player.mo.z)
				end
			elseif player.airboost == false
			and player.boosting == false
			or player.speed < FixedMul(45*FRACUNIT, player.mo.scale)
				if (player.boostmobj1 and player.boostmobj1.valid)
					S_StopSound(player.boostmobj1)
					P_RemoveMobj(player.boostmobj1)
				end
				if (player.boostmobj2 and player.boostmobj2.valid)
					S_StopSound(player.boostmobj2)
					P_RemoveMobj(player.boostmobj2)
				end
				player.ringrange = 0
				if player.sonic_ringrange and player.sonic_ringrange.valid
					P_RemoveMobj(player.sonic_ringrange)
				end
				
				player.charflags = $1 & ~SF_NOSKID
			end
			if player.speed >= FixedMul(45*FRACUNIT, player.mo.scale)
			and player.airboost == true
			and not (P_IsObjectOnGround(player.mo))
			and not (P_PlayerInPain(player))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_carry])
				if player.mo.state == S_PLAY_AIRBOOST
				or player.boostheld == true
					local boostaura = P_SpawnMobj(player.mo.x, player.mo.y, player.flipthisboost, MT_BOOSTAURA)
					local boostsparkle = A_BossScream(player.mo, 0, MT_BOXSPARKLE)
					boostaura.target = player.mo
					if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_FLAMEAURA)
					and player.powers[pw_super] == 0
					and not (player.mo.eflags & MFE_UNDERWATER)
							boostaura.color = SKINCOLOR_ORANGE
					elseif player.mo.color ~= SKINCOLOR_BLUE
						boostaura.color = boostaura.target.color
					else 
						boostaura.color = SKINCOLOR_SAPPHIRE
					end
					boostaura.scale = player.mo.scale
					boostaura.angle = R_PointToAngle2(boostaura.x, boostaura.y, (boostaura.target.x+boostaura.target.momx), (boostaura.target.y+boostaura.target.momy))
					P_TeleportMove(boostaura, player.mo.x, player.mo.y, player.flipthisboost)
					if (leveltime % 2 == 0)
						boostaura.flags2 = $1 & ~MF2_DONTDRAW
					else
						boostaura.flags2 = $1|MF2_DONTDRAW
					end
					local boostafterimage = P_SpawnGhostMobj(boostaura)
					boostafterimage.fuse = 4
					boostafterimage.target = player.mo
					boostafterimage.frame = $1|FF_FULLBRIGHT
					boostafterimage.scale = P_RandomRange(4000/3, 2000/3)*player.mo.scale/1000
				end
				if player.airboost == true
				and player.mo.state ~= S_PLAY_AIRBOOST
				and player.boostheld == true
					if not (player.boostmobj1 and player.boostmobj1.valid) then
						player.boostmobj1 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_GFZFLOWER1)
						player.boostmobj1.flags2 = $1|MF2_DONTDRAW
						if not (player.mo.eflags & MFE_UNDERWATER)
							S_StartSound(player.boostmobj1, sfx_boost3)
						else
							S_StartSound(player.boostmobj1, sfx_wtbst3)
						end
						P_TeleportMove(player.boostmobj1, player.mo.x, player.mo.y, player.mo.z)
					elseif (player.boostmobj1 and player.boostmobj1.valid)
						P_TeleportMove(player.boostmobj1, player.mo.x, player.mo.y, player.mo.z)
					end
					if not (player.boostmobj2 and player.boostmobj2.valid) then
						player.boostmobj2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_GFZFLOWER1)
						player.boostmobj2.flags2 = $1|MF2_DONTDRAW
						P_TeleportMove(player.boostmobj2, player.mo.x, player.mo.y, player.mo.z)
					elseif (player.boostmobj2 and player.boostmobj2.valid)
						if not (player.mo.eflags & MFE_UNDERWATER)
							if not (S_SoundPlaying(player.boostmobj2, sfx_boost4))
								S_StartSound(player.boostmobj2, sfx_boost4)
							end
						else
							if not (S_SoundPlaying(player.boostmobj2, sfx_wtbst4))
								S_StartSound(player.boostmobj2, sfx_wtbst4)
							end
						end
						P_TeleportMove(player.boostmobj2, player.mo.x, player.mo.y, player.mo.z)
					end
				end
			end
			if player.boosting == true
			or player.superboost == true
			or player.sliding == 1
			or player.homing
			or player.mo.state == S_PLAY_AIRBOOST
			or player.lightdashing > 0
				if player.flungrange == 0
				or player.flungrange == nil
					player.sonic_flung = P_SpawnMobj(player.mo.x , player.mo.y, player.mo.z, MT_FAKEAURA)
					player.sonic_flung.scale = player.mo.scale
					player.sonic_flung.height = player.mo.height
					player.sonic_flung.radius = player.mo.radius
					player.sonic_flung.target = player.mo
					player.flungrange = 1
				end
				if player.sonic_flung.valid
					if player.boosting == true
					or player.superboost == true
						player.sonic_flung.radius = player.mo.radius*3
					elseif player.sliding == 1
						player.sonic_flung.radius = player.mo.radius*2
					elseif player.homing
						player.sonic_flung.radius = player.mo.radius*4
					end
					if player.homing
						P_TeleportMove(player.sonic_flung, player.mo.x, player.mo.y, player.mo.z-10*FRACUNIT)
					else
						P_TeleportMove(player.sonic_flung, player.mo.x, player.mo.y, player.mo.z)
					end
				end
			else
				player.flungrange = 0
				if player.sonic_flung and player.sonic_flung.valid
					P_RemoveMobj(player.sonic_flung)
				end
			end
			if player.speed < FixedMul(45*FRACUNIT, player.mo.scale)
			and (player.boosting == true or player.superboost == true)
			and player.boostcanceltimer == 0
				if (player.boostheld == false or player.mo.state == S_PLAY_SPRING)
				or (player.boostheld == true and (player.mo.state == S_PLAY_WALK) or (player.mo.state == S_PLAY_STND))
				or (not (P_IsObjectOnGround(player.mo)))
					player.boosting = false
					player.superboost = false
				end
			end
			if P_IsObjectOnGround(player.mo)
			and not (player.pflags & (PF_SPINNING|PF_STARTDASH))
			and not (player.powers[pw_carry])
			//and not (player.powers[pw_super])
			and player.sliding == 0
			and player.playerstate == PST_LIVE
				player.superboost = false
				if (player.speed > FixedMul(50*FRACUNIT, player.mo.scale) and player.powers[pw_super] == 0)
				or (player.speed > FixedMul(80*FRACUNIT, player.mo.scale) and player.powers[pw_super])
					player.mo.state = S_PLAY_BOOSTRUN
				end
			end
			if player.sonic_rings
				for i = table.maxn(player.sonic_rings), 1, -1
					local ring = player.sonic_rings[i]
					if not (ring.valid and ring.health)
						table.remove(player.sonic_rings,i)
						continue
					end
					if not ring.ringchasetimer
						P_RemoveMobj(ring)
						table.remove(player.sonic_rings,i)
						continue
					end
					if P_AproxDistance(player.mo.z - ring.z,P_AproxDistance(player.mo.x - ring.x, player.mo.y - ring.y)) <= 256*player.mo.scale
						ring.flags = $ & ~MF_NOCLIP
						local xdist = ring.x - player.mo.x
						local ydist = ring.y - player.mo.y
						local zdist = ring.z - (player.mo.z + player.mo.height/2)
					else
						ring.flags = $ | MF_NOCLIP
					end
					ring.ringchasetimer = $ - 1
					A_HomingChase(ring,min((6*TICRATE-ring.ringchasetimer)*8, max(48, FixedHypot(FixedHypot(player.mo.momx, player.mo.momy), player.mo.momz)/FRACUNIT + 100))*ring.scale)
				end
			end	
			if player.flungenemy
				for i = table.maxn(player.flungenemy), 1, -1
					local enemy = player.flungenemy[i]
					if not (enemy.valid and enemy.health)
						table.remove(player.flungenemy,i)
						continue
					end
					if not enemy.flungtimer
					and enemy.valid
					//and enemy.health
						if enemy.info.deathsound == sfx_pop
						or enemy.type == MT_FACESTABBER
							PlayEnemySound(enemy, TYPE_DEATH)
						end
						P_KillMobj(enemy, enemy.target, enemy.target)
						if enemy.target
						and enemy.target.valid
							P_AddPlayerScore(enemy.target.player, 100)
							enemy.target.player.boostmeter = $1+10
						end
						enemy.target.player.boostmeter = $1+10
						table.remove(player.flungenemy,i)
						continue
					end
					if InDeathAnimation(enemy)
						if enemy.target
						and enemy.target.valid
							P_AddPlayerScore(enemy.target.player, 100)
							enemy.target.player.boostmeter = $1+10
						end
						if enemy.info.deathsound == sfx_pop
						or enemy.type == MT_FACESTABBER
							PlayEnemySound(enemy, TYPE_DEATH)
						end
						table.remove(player.flungenemy,i)
						continue
					end
					enemy.flungtimer = $ - 1
					enemy.angle = $+ANG10
					if enemy.flungtimer < 15
						enemy.flags = $|MF_MISSILE
					end
					if (leveltime % 2 == 0)
					and enemy
					and enemy.valid
						P_InstaThrust(enemy, enemy.flingangle, FixedMul(enemy.flingspeed, player.mo.scale))
					end
				end
			end
		end
	end
end)


//Handles attracting rings
addHook("MobjMoveCollide", function(eb, item)
	if eb and eb.target and eb.target.valid and eb.target.player and P_CanPickupItem(eb.target.player) and not P_PlayerInPain(eb.target.player) and item and item.valid and eb.z <= item.z + item.height*10 and eb.z + eb.height >= item.z
	and not item.soncattract and (item.type == MT_RING or item.type == MT_COIN or eb.target.player.ctfteam == 1 and item.type == MT_REDTEAMRING or eb.target.player.ctfteam == 2 and item.type == MT_BLUETEAMRING)
		item.soncattract = true
		item.target = eb.target
		item.ringchasetimer = 6*TICRATE
		if not eb.target.player.sonic_rings then eb.target.player.sonic_rings = {} end
		table.insert(eb.target.player.sonic_rings,item)
	end
end, MT_RINGRANGE)

//Handles Flinging enemies
addHook("MobjMoveCollide", function(eb, enemy)
	if eb and eb.target and eb.target.valid and eb.target.player and not P_PlayerInPain(eb.target.player) and enemy and enemy.valid and eb.z <= enemy.z + enemy.height*2 and eb.z + eb.height >= enemy.z
	and not enemy.flung and ((enemy.flags & MF_ENEMY) or enemy.type == MT_TNTBARREL) and not (enemy.flags2 & MF2_FRET) and enemy.health > 0 
	and enemy.health < 2
		enemy.target = eb.target
		enemy.flung = true
		enemy.flungtimer = 20
		enemy.flingspeed = eb.target.player.speed+10*FRACUNIT
		enemy.flingangle = eb.target.player.drawangle + P_RandomRange(-10, 10)*ANG1
		enemy.flags = $&~(MF_SHOOTABLE|MF_ENEMY|MF_NOGRAVITY|MF_SPECIAL)
		if enemy.type == MT_PYREFLY 
		or enemy.type == MT_PYREFLY_FIRE
		or enemy.type == MT_PTERABYTE
			enemy.flags = $|MF_SCENERY
		end
		if enemy.type == MT_CRUSHSTACEAN
			P_KillMobj(enemy, eb.target, eb.target)
			P_AddPlayerScore(eb.target.player, 100)
			eb.target.player.boostmeter = $1+10
		end
		if eb.target.player.homing
			P_InstaThrust(enemy, eb.target.angle, FixedMul(eb.target.player.actionspd+10*FRACUNIT, eb.target.scale))
			P_SetObjectMomZ(enemy, FixedMul(10*FRACUNIT, eb.target.scale))
		else
			P_InstaThrust(enemy, eb.target.player.drawangle, FixedMul(enemy.flingspeed, eb.target.scale))
			P_SetObjectMomZ(enemy, FixedMul(eb.target.player.speed/10, eb.target.scale))
		end
		if (eb.target.player.boosting == true or eb.target.player.airboost == true or eb.target.player.homing)
		and eb.target.player.boostshake < 3
			eb.target.player.boostshake = 3
		end
		enemy.tics = -1
		if enemy.info.deathsound == sfx_pop
		or enemy.type == MT_FACESTABBER
			PlayEnemySound(enemy, TYPE_HIT)
		end
		if not eb.target.player.flungenemy then eb.target.player.flungenemy = {} end
		table.insert(eb.target.player.flungenemy,enemy)
	end
end, MT_FAKEAURA)

//Gives the player boost energy for killing enemies
addHook("MobjDeath", function(enemy, msonic, msonic)
	if (msonic and msonic.valid and msonic.skin == "modernsonic")
		if (enemy and enemy.valid and enemy.flags & (MF_ENEMY|MF_SHOOTABLE))
		and not (enemy.player)
		and not (enemy.flags & MF_BOSS)
			if (msonic.player.boostmeter < 117)
				msonic.player.boostmeter = $1+10
			end
		end
		if enemy and enemy.valid
			if enemy.type == MT_FLINGRING
			or enemy.type == MT_FLINGCOIN
				if msonic.player.boostmeter > 0
					msonic.player.boostmeter = $1-3
				end
			end
		end
		return false
	end
end)

//Vertical spike killer
addHook("MobjCollide", function(spike, sonic)
	if not (sonic.player and sonic.skin == "modernsonic")
	return nil 
	end
	if sonic.player.boosting == false
	and sonic.state ~= S_PLAY_AIRBOOST
	return nil
	end
	if (sonic.z > spike.z+spike.height)
	or (spike.z > sonic.z+sonic.height)
		return nil 
	else
		spike.health = 0
		S_StartSound(sonic, spike.info.deathsound)
		P_KillMobj(spike, sonic, sonic)
		sonic.player.boostmeter = $1+2
	return false 
	end
end, MT_SPIKE)

//Horizontal spike killer
addHook("MobjCollide", function(spike, sonic)
	if not (sonic.player and sonic.skin == "modernsonic")
	return nil 
	end
	if sonic.player.stomping == false
	return nil
	end
	if (sonic.z > spike.z+spike.height*2)
	or (spike.z > sonic.z+sonic.height)
		return nil 
	else
		spike.health = 0
		S_StartSound(sonic, spike.info.deathsound)
		P_KillMobj(spike, sonic, sonic)
		sonic.player.boostmeter = $1+2
	return false 
	end
end, MT_WALLSPIKE)
	
//Allows the boost to damage bosses and enemies with extra health
addHook("MobjMoveCollide", function(boostaura, mobj)
	for player in players.iterate
		if boostaura.skin == "modernsonic"
			if boostaura.player.boosting == true
			or boostaura.player.sliding == 1
			or boostaura.state == S_PLAY_AIRBOOST
				if (mobj.valid and mobj.health)
					if( boostaura.z > mobj.z+mobj.height) or (mobj.z > boostaura.z+boostaura.height)
						return nil
					end
					if mobj.flags & MF_BOSS
					and not (mobj.flags2 & MF2_FRET)
					and mobj.health > 1
						P_DamageMobj(mobj, boostaura, boostaura.target, 1)
						boostaura.player.boostmeter = $1+3
						boostaura.player.boosting = false
						boostaura.player.airboost = false
						P_InstaThrust(boostaura, R_PointToAngle2(boostaura.x, boostaura.y, (boostaura.x-boostaura.momx), (boostaura.y-boostaura.momy)), boostaura.player.speed)
						return false 
					end
					if mobj.flags & MF_ENEMY
					and not (mobj.flags2 & MF2_FRET)
					and mobj.health >= 2
						P_DamageMobj(mobj, boostaura, boostaura.target, 1)
						boostaura.player.boosting = false
						boostaura.player.airboost = false
						P_InstaThrust(boostaura, R_PointToAngle2(boostaura.x, boostaura.y, (boostaura.x-boostaura.momx), (boostaura.y-boostaura.momy)), boostaura.player.speed)
						boostaura.player.powers[pw_nocontrol] = 3
						return false 
					end
				end
			end
		end
	end
end, MT_PLAYER)

//This just makes it so you dont get hurt by enemies while doing certain actions. Also to prevent the walljump object from actually damaging players...because that was a thing for some reason.
addHook("ShouldDamage", function(target, inflictor, source, damage)
	if target and target.valid
		if target.skin == "modernsonic" 
			if target.player.boosting == true
			or target.player.sliding == 1
			or target.state == S_PLAY_AIRBOOST
			or target.player.lightdashing > 0
				if (inflictor and inflictor.valid )
					if (inflictor.flags & MF_ENEMY or inflictor.flags & MF_BOSS)
						return false
					end
				end
			end
		end
	end
end, MT_PLAYER)

addHook("ShouldDamage", function(target, inflictor, source, damage)
	if target.flags & MF_ENEMY
	and target.health < 2
		if (inflictor and inflictor.valid )
		and (inflictor.type == MT_PLAYER)
		and (inflictor.skin == "modernsonic")
			if inflictor.player.boosting == true
			or inflictor.player.sliding == 1
			or inflictor.state == S_PLAY_AIRBOOST
			or inflictor.player.lightdashing > 0
			or inflictor.player.homing
				return false
			end
		end
	end
end, MT_NULL)

addHook("ShouldDamage", function(target, inflictor, source, damage)
	if target and target.valid
	and inflictor and inflictor.valid
		return false
	end
end, MT_WALLJUMP)

addHook("MobjThinker", function(minecart)
	if minecart and minecart.valid
	and minecart.target 
	and minecart.target.type == MT_PLAYER
		if minecart.target.player.boosting == true
			minecart.target.player.boosting = false
			minecart.target.player.minecartboost = true
		end
		if P_IsObjectOnGround(minecart)
			if minecart.target.player.minecartboost == true
				P_InstaThrust(minecart, minecart.angle, 35*FRACUNIT)
			else
				local speed = FixedHypot(minecart.momx, minecart.momy)
				if speed > FixedMul(30*FRACUNIT, minecart.target.scale)
					P_InstaThrust(minecart, minecart.angle, 20*FRACUNIT)
				end
			end
		else 
			local speed = FixedHypot(minecart.momx, minecart.momy)
			if speed > FixedMul(30*FRACUNIT, minecart.target.scale)
				minecart.momx = $1*5/6
				minecart.momy = $1*5/6
			end
		end
	end
end, MT_MINECART)


