//Ring Sound code from TrickyTex with minor help from Tatsuru
//Offered as beta. Remove this second comment if final.

addHook("ThinkFrame", function()
for player in players.iterate do if player and player.valid and player.mo and player.mo.valid then
	if player.ringseq == nil then player.ringseq = 0 end //init the ring sequencer
	if player.ringdif == nil then player.ringdif = 0 end
	if player.ringseq > 2 then player.ringseq = 0 end //the sequencer can only be 0, 1, or 2
end end
end)



local sound_engines = {
MT_RING,
MT_REDTEAMRING,
MT_BLUETEAMRING,
MT_FLINGRING,
MT_AUTOMATICRING,
MT_BOUNCERING,
MT_SCATTERRING,
MT_EXPLOSIONRING,
MT_GRENADERING,
MT_RAILRING,
MT_INFINITYRING

}

local function ringEngine(special, toucher)
    if special and special.valid and toucher and toucher.valid and toucher.player and toucher.player.valid and toucher.skin == "modernsonic" then
        local player = toucher.player
        mobjinfo[special.type].deathsound = player.ringseq == 0 and sfx_itemu1 or player.ringseq == 1 and sfx_itemu2 or sfx_itemu3
        player.ringseq = $ + 1 //increase the sequence by 1
    else
        mobjinfo[special.type].deathsound = sfx_itemup
    end
end

for i = 1,#sound_engines do
    addHook("TouchSpecial", ringEngine, sound_engines[i])
end