//Adds the ability to detect bustable FOF's
rawset(_G, "sonicboostblockbuster", function(player, bustsec)
	for rover in bustsec.ffloors() // search through FOFs in sector
		if not (rover.flags & FF_EXISTS) continue end // FOF does not "exist" in sector!
		if not (rover.flags & FF_BUSTUP) continue end // FOF is not bustable, ignore it
		
		if player.stomping == false
		or player.mo.state == S_PLAY_AIRBOOST
			if player.mo.z >= rover.topheight // too high
		
				continue
			end
		end

		if player.mo.z+player.mo.momz+player.mo.height < rover.bottomheight // too low
			continue
		end
		player.boostmeter = $1+30
		player.boostshake = 10
		EV_CrumbleChain(bustsec, rover) // DESTROY IT
	end
end)

//Now allows the player to break walls while doing certain actions.
addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "modernsonic")
		and player.playerstate == PST_LIVE
		and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			if player.boosting == true
			or player.stomping == true
			or player.mo.state == S_PLAY_AIRBOOST
			or player.superboost == true
				local sectordetector = R_PointInSubsector(player.mo.x, player.mo.y).sector

				sonicboostblockbuster(player, sectordetector) // check sector you're in
		
				if R_PointInSubsector(player.mo.x+(player.mo.momx/2), player.mo.y + (player.mo.momy/2)).sector != sectordetector
					sectordetector = R_PointInSubsector(player.mo.x+(player.mo.momx/2), player.mo.y + (player.mo.momy/2)).sector
					sonicboostblockbuster(player, sectordetector) // sector half-way to next
				end
				if R_PointInSubsector(player.mo.x+(player.mo.momx), player.mo.y + (player.mo.momy)).sector != sectordetector
					sectordetector = R_PointInSubsector(player.mo.x+(player.mo.momx), player.mo.y + (player.mo.momy)).sector
					sonicboostblockbuster(player, sectordetector) // sector at next frame
				end
				if R_PointInSubsector(player.mo.x+(player.mo.momx*2), player.mo.y + (player.mo.momy*2)).sector != sectordetector
					sectordetector = R_PointInSubsector(player.mo.x+(player.mo.momx*2), player.mo.y + (player.mo.momy*2)).sector
					sonicboostblockbuster(player, sectordetector) // sector at frame after
				end		
			end
		end
	end
end)

